'use strict'


import Parser from './util/parser'
const REACT_IDENTIFIER = 'react'



export default (babel)=>{
  const {types:t} = babel
  return {
    visitor:{
      ClassDeclaration(path,{opts}){
          const{node} = path
          if (!node || !node.superClass) return 
          Parser.getSuperClassName(t,node)
      },
      ImportDeclaration(path,{opts}){
        const{node} = path
        if (!node) return
        if(node.source.value === REACT_IDENTIFIER){
          node.specifiers.forEach((specifier)=>{
            Parser.getImportIdentifiers(t,specifier)
          })
        }
      },
      ExportDefaultDeclaration(path,{opts}){
        const{node} = path
        const{lib} = opts
        if (!node) return
        path.traverse({
          Identifier(ipath) {
            Parser.changeExportExpression(t,lib,ipath,path)
          }
        });
        
      }
    }
  }
}