'use strict'

let import_component_identifier
,import_react_identifier
,export_component_identifier

const RENDER_NAME = 'PureVisulizerRender'
export default  {
	getSuperClassName(t,node){
	  const{superClass} = node
	  let supClassName
      if(t.isMemberExpression(superClass)){
        supClassName = `${superClass.object.name}.${superClass.property.name}`
      }else if(t.isIdentifier(superClass)){
        supClassName = superClass.name
      }
      if(supClassName && supClassName === import_component_identifier){
        export_component_identifier = node.id.name
        console.log('export_component_identifier :',export_component_identifier)
      }
	},
	getImportIdentifiers(t,specifier){
	    if(t.isImportSpecifier(specifier)){
	      import_component_identifier = specifier.imported.name
	    }else if(t.isImportDefaultSpecifier(specifier)){
	      import_react_identifier = specifier.local.name
	      import_component_identifier = `${specifier.local.name}.Component`
	    }
	},
	changeExportExpression(t,lib='babel-plugin-react-visualizer-dev/lib/component',path,pPath){
		const{node} = path
		if(export_component_identifier && node.name === export_component_identifier){
			pPath.insertBefore(t.importDeclaration(
				[t.ImportDefaultSpecifier(
					t.identifier(RENDER_NAME),
				)],
				t.stringLiteral(lib)
			))
			path.replaceWithSourceString(`${RENDER_NAME}(${export_component_identifier})`)
			export_component_identifier = null
		} 
	}
}